
.386 
.model flat, stdcall
option casemap:none

;---------------------------------------------------------------------------]
;--includes and libs for DialHound
        include         \masm32\include\windows.inc
        include         \masm32\include\user32.inc
        include         \masm32\include\kernel32.inc
        include         \masm32\include\gdi32.inc
        includelib      \masm32\lib\user32.lib
        includelib      \masm32\lib\kernel32.lib
        includelib      \masm32\lib\gdi32.lib
        
        include         lib\tipday.inc
        includelib      lib\tipday.lib
;---------------------------------------------------------------------------]


;---------------------------------------------------------------------------]
;--local function prototypes
        WndProc         PROTO   :DWORD, :DWORD, :DWORD, :DWORD
;---------------------------------------------------------------------------]


.DATA
;---------------------------------------------------------------------------]
        szStartup       DB      "You selected to show tips on startup",0
        szNoStartup     DB      "You selected not to show tips on startup",0
        szAbout         DB      13,10
                        DB      "TipDay v1.0",13,10
                        DB      "Coded by Prof. DrAcULA",13,10,13,10
                        DB      "on May 31, 2005.",13,10,13,10
                        DB      "All rights reserved",13,10,13,10
                        DB      "Greetz & thx : ",13,10
                        DB      "My Girly :)",0
        ShowIt          DB      0
;---------------------------------------------------------------------------]


.DATA?
;---------------------------------------------------------------------------]
;--uninitialized data
hInstance               DD              ?               ;--for program handle
hDlg                    DD              ?               ;--for window handle
CommandLine             DD              ?               ;--for commandline
ExitCode                DD              ?               ;--for exitcode
Tip                     DD              ?
;---------------------------------------------------------------------------]


.CONST
;---------------------------------------------------------------------------]
;--resources in our program
        ID_DIALOG               EQU             100
        ID_TIP                  EQU             101
        ID_EXIT                 EQU             102
        ID_EDIT                 EQU             103
;---------------------------------------------------------------------------]


.CODE
;---------------------------------------------------------------------------]
;--execution starts here
START:
        invoke  GetModuleHandle, 0      ;--get program handle
        mov     hInstance, eax          ;--store it in hInstance
        invoke  GetCommandLine          ;--get commandline args
        mov     CommandLine, eax        ;--move args to CommandLine
        invoke  DialogBoxParam, hInstance, ID_DIALOG, 0, offset WndProc, 0      ;--show our window
        invoke  ExitProcess, eax        ;--close our program
;---------------------------------------------------------------------------]


;---------------------------------------------------------------------------]
;--our Window procedure
WndProc PROC    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
        mov     eax, uMsg               ;--get message in eax
        cmp     eax, WM_INITDIALOG      ;--if initialization
        jz      _INITDIALOG             ;--goto init-routine
        cmp     eax, WM_COMMAND         ;--if its COMMAND
        jz      _COMMAND                ;--go to Command-routine
        cmp     eax, WM_CLOSE           ;--if its CLOSE
        jz      _CLOSE                  ;--go to Close-routine
        
   _DEFAULT:
        xor     eax, eax
        ret
        
  _INITDIALOG:
        invoke  GetDlgItem, hWnd, ID_EDIT 
        invoke  SendMessageA, eax, WM_SETTEXT, 0, offset szAbout
        xor     eax, eax
        ret
        
   _CLOSE:
        invoke  EndDialog, hWnd, 0              ;--close our window
        xor     eax, eax
        ret
                        
   _COMMAND:
        mov     eax, wParam
        cmp     ax, ID_TIP
        jz      _TIP
        cmp     ax, ID_EXIT                     ;--if user clicked on Exit-button
        jz      _CLOSE                          ;--jump to Close-routine
        xor     eax, eax
        ret
        
  _TIP:
        .if ShowIt==0
                invoke  ShowTipDay, 0, 0
                mov     ShowIt, 1
        .else
                invoke  ShowTipDay, 1, 1
                mov     ShowIt, 0
        .endif                    
        mov     Tip, eax
        invoke  GetDlgItem, hWnd, ID_EDIT 
        .if Tip==0
                invoke  SendMessageA, eax, WM_SETTEXT, 0, offset szStartup
        .else
                invoke  SendMessageA, eax, WM_SETTEXT, 0, offset szNoStartup
        .endif
        xor     eax, eax
        ret
                
WndProc ENDP 
;---------------------------------------------------------------------------]

END START